#include <stdlib.h>
#include <stdio.h>
#include <time.h>

int main(int argc, char ** argv)
{
  int i;
  long int n,* tableau, min, max;
  long int debut, apres_premier, apres_second;

  /*Initialisations*/
  if (argc!=2){
    fprintf(stderr,"Le programme prend obligatoirement un argument\n");
    return(-1);
  }
  n = atol(argv[1]);
  tableau = malloc(n*sizeof(long int));
  for(i=0; i<n; i++) tableau[i] = random();
  debut  = clock();


  /*Premier algorithme*/
  min = tableau[0];
  max = tableau[0];
  for(i=1; i<n; i++){
    if (tableau[i] > max) max = tableau[i];
    if (tableau[i] < min) min = tableau[i];
  }
  apres_premier = clock();

  /*Second algorithme*/
  if (tableau[1]>tableau[0]){
    min = tableau[0];
    max = tableau[1];
  }
  else{
    min = tableau[1];
    max = tableau[0];
  }
  
  for(i=2; i<n-1; i+=2){
    if (tableau[i+1]>tableau[i]){
      if (tableau[i+1] > max) max = tableau[i+1];
      if (tableau[i] < min) min = tableau[i];
    }
    else{
      if (tableau[i] > max) max = tableau[i];
      if (tableau[i+1] < min) min = tableau[i+1];
    }
  }
  if ((n%2)!=0){
      if (tableau[n] > max) max = tableau[n];
      if (tableau[n] < min) min = tableau[n];
  }
  apres_second  = clock();

  /* Affichage des temps d'execution*/
  fprintf(stderr,"Premier  algorithme: %.3lf\nDeuxieme algorithme: %.3lf\n",
	  (1.0*(apres_premier-debut))/CLOCKS_PER_SEC, 
	  (1.0*(apres_second-apres_premier))/CLOCKS_PER_SEC);
  return 0;
}
